import java.net.*;
import java.io.*;
import java.util.*;
import java.nio.charset.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;


public class LocationServer implements Runnable {
	static Hashtable table;	//ΥHsLocationServer
	static ServerSocket listener;
	Socket mySocket;		//LocationServer󤺪suSocket
	String username;		//ϥΪ̪κ
    float x, y,msg,name2,xx,yy,sex               //ϥΪ̪ϥܦm
	
	//غc禡
	public LocationServer(Socket mySocket) {
		this.mySocket = mySocket;
	}

	//kwq
	public void run() {
		try {
            sendOthers();
			//ǳƱrһݪ
			InputStream in = mySocket.getInputStream();
			BufferedReader bReader = new BufferedReader(
				new InputStreamReader(in, Charset.forName("UTF-8")));

            String data = bReader.readLine();
            String name = getAtt(data, "name");
            this.username = name;
            float x, y,msg,name2,xx,yy,sex
			//N󥻨]LocationServer^[JHashtable
            table.put(this.username, this);
            sendToAll(data);

            
			//YS_uA򱵦
			while(mySocket.isConnected()) {
				data = bReader.readLine();
                if(data.indexOf("name")<0)
                    throw new Exception("u");
                name = getAtt(data, "name");
                x = Float.parseFloat(getAtt(data, "x"));
                y = Float.parseFloat(getAtt(data, "y"));
		msg = Float.parseFloat(getAtt(data, "msg"));
		name2 = Float.parseFloat(getAtt(data, "name2"));
		xx = Float.parseFloat(getAtt(data, "xx"));
		yy = Float.parseFloat(getAtt(data, "yy"));
		sex = Float.parseFloat(getAtt(data, "sex"));
                LocationServer obj = (LocationServer)table.get(name);
                obj.x = x;
                obj.y = y;
                obj.xx = xx;
                obj.yy = yy;
		obj.msg = msg;
		obj.sex = sex;
		obj.name2 = name2;
                
                sendToAll(data);
			}
		}
		catch(Exception ex){
            //ex.printStackTrace();
        }
		finally {
			try {
				mySocket.close();	//su
			}catch(IOException ex){}
            System.out.println(":"+this.username);
			//qHashtable󲾰󥻨
            table.remove(this.username);

            //qLϥΪ
            sendToAll("<user name=\""+
                this.username+"\" kill=\"true\" />");
		}
	}

	//qXMLrꤤoYݩʭ
	String getAtt(String xml, String str) throws Exception{
		//Ŧrťզr
		xml = xml.replace('\0', ' ');
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		//NXMLܦDOM
		Document doc = db.parse(new InputSource(new StringReader(xml)));
		//^ݩ
		return doc.getDocumentElement().getAttribute(str);
	}
    
	//eXTRAk
	static synchronized void sendToAll(String msg) {
		//oXƾ
		Iterator iterator = table.values().iterator();

		//C|Cvalue
        while(iterator.hasNext()) {
			try {
				LocationServer locServer = (LocationServer)iterator.next();
				OutputStream out = locServer.mySocket.getOutputStream();
				BufferedWriter bWriter = new BufferedWriter(
					new OutputStreamWriter(out, Charset.forName("UTF-8")));
				bWriter.write(msg);
				bWriter.write(0);	//[Wr
				bWriter.flush();	//eX
			}
			catch(IOException ex){
				System.out.println("oͨҥ~G"+ex);
			}
		}
	}
	
	//^ǤjULH
	void sendOthers() throws Exception {
		String str = "";
		//oXƾ(C|)
		Iterator iterator = table.values().iterator();
        
		//C|Cvalue
        while(iterator.hasNext()) {
            LocationServer locServer = (LocationServer)iterator.next();
            String tmp = "<user name=\""+locServer.username+"\" x=\""+locServer.x+"\" y=\""+locServer.y"\" msg=\""+locServer.msg+"\" name2=\""+locServer.name2+"\" xx=\""+locServer.xx+"\" yy=\""+locServer.yy+"\" sex=\""+locServer.sex+"\" />";
            str += tmp;
		}
		if(str.length()>0) {
            OutputStream out = mySocket.getOutputStream();
            BufferedWriter bWriter = new BufferedWriter(
                new OutputStreamWriter(out, Charset.forName("UTF-8")));
            bWriter.write(str);
            bWriter.write(0);	//[Wr
            bWriter.flush();	//eX
        }
	}
			finally {
			try {
				mySocket.close();	//su
			}catch(IOException ex){}
            System.out.println(":"+this.username);
			//qHashtable󲾰󥻨
            table.remove(this.username);

            //qLϥΪ
            sendToAll("<user name=\""+
                this.username+"\" kill=\"true\" />");
		}
	}

	//D
	public static void main(String arg[]) {
		//إHashtable
		table = new Hashtable();
		try {
			//]wť
			listener = new ServerSocket(5678);
			System.out.println("AҰʡAЫ Ctrl-CC");
			
			while(true) {
				//ݳs
				Socket mySocket = listener.accept();
				LocationServer myServer = new LocationServer(mySocket);
				//H覡LocationServer
				Thread myThread = new Thread(myServer);
				myThread.start();
			}
		}
		catch(IOException ex){
			System.out.println("s~I");
		}
		catch(Exception ex){
			System.out.println("oͨҥ~G"+ex.toString());
		}
		finally {	
			try {	
				listener.close();	//ServerSocket
			}catch(IOException ex) {}
		}
	}
}